/*
 *  KernelEx
 *  Copyright (C) 2008, Xeno86
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef _GDI32_APILIST_H
#define _GDI32_APILIST_H

#include "kexcoresdk.h"

BOOL init_gdi32();
extern const apilib_api_table apitable_gdi32;

/*** AUTOGENERATED APILIST DECLARATIONS BEGIN ***/
int WINAPI GetGlyphIndicesW_new(HDC hdc, LPWSTR lpstr, int c, LPWORD pgi, DWORD fl);
int WINAPI GetGlyphIndicesA_new(HDC hdc, LPCSTR lpstr, int c, LPWORD pgi, DWORD fl);
BOOL WINAPI GetTextExtentExPointI_new(HDC hdc, LPWORD pgiIn, int cgi, int nMaxExtent, LPINT lpnFit, LPINT alpDx, LPSIZE lpSize);
BOOL WINAPI GetTextExtentPointI_new(HDC hdc, LPWORD pgiIn, int cgi, LPSIZE lpSize);
BOOL WINAPI GetCharWidthI_new(HDC hdc, UINT giFirst, UINT cgi, WORD* pgi, INT* lpBuffer);
BOOL WINAPI GetCharABCWidthsI_new(HDC hdc, UINT giFirst, UINT cgi, LPWORD pgi, LPABC lpabc);
BOOL WINAPI GetCharABCWidthsW_new(HDC hdc, UINT uFirstChar, UINT uLastChar, LPABC lpabc);
DWORD WINAPI GetGlyphOutlineW_new(HDC hdc, UINT uChar, UINT uFormat, LPGLYPHMETRICS lpgm, DWORD cbBuffer, LPVOID lpvBuffer, CONST MAT2 *lpmat2);
FWDPROC CopyEnhMetaFileW_fwd;
FWDPROC CopyMetaFileW_fwd;
FWDPROC CreateColorSpaceW_fwd;
FWDPROC CreateDCW_fwd;
FWDPROC CreateEnhMetaFileW_fwd;
FWDPROC CreateFontIndirectW_fwd;
FWDPROC CreateFontW_fwd;
FWDPROC CreateICW_fwd;
FWDPROC CreateMetaFileW_fwd;
FWDPROC CreateScalableFontResourceW_fwd;
FWDPROC EnumICMProfilesW_fwd;
FWDPROC GetCharacterPlacementW_fwd;
FWDPROC GetEnhMetaFileDescriptionW_fwd;
FWDPROC GetEnhMetaFileW_fwd;
FWDPROC GetICMProfileW_fwd;
FWDPROC GetKerningPairsW_fwd;
FWDPROC GetLogColorSpaceW_fwd;
FWDPROC GetMetaFileW_fwd;
FWDPROC GetOutlineTextMetricsW_fwd;
FWDPROC GetTextExtentExPointW_fwd;
FWDPROC GetTextFaceW_fwd;
FWDPROC GetTextMetricsW_fwd;
FWDPROC ResetDCW_fwd;
FWDPROC SetICMProfileW_fwd;
FWDPROC StartDocW_fwd;
FWDPROC UpdateICMRegKeyW_fwd;
/*** AUTOGENERATED APILIST DECLARATIONS END ***/

#endif
