/*
 *  KernelEx
 *  Copyright (C) 2008, Xeno86
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "common.h"
#include "kexcoresdk.h"
#include "_user32_apilist.h"

BOOL init_user32()
{
	return TRUE;
}

static const apilib_named_api user32_named_apis[] = 
{
/*** AUTOGENERATED APILIST NAMED EXPORTS BEGIN ***/
	DECL_API("BroadcastSystemMessageW", BroadcastSystemMessageW_fwd),
	DECL_API("ChangeDisplaySettingsExW", ChangeDisplaySettingsExW_fwd),
	DECL_API("ChangeDisplaySettingsW", ChangeDisplaySettingsW_fwd),
	DECL_API("DdeCreateStringHandleW", DdeCreateStringHandleW_fwd),
	DECL_API("DdeInitializeW", DdeInitializeW_fwd),
	DECL_API("DdeQueryStringW", DdeQueryStringW_fwd),
	DECL_API("DlgDirListComboBoxW", DlgDirListComboBoxW_fwd),
	DECL_API("DlgDirListW", DlgDirListW_fwd),
	DECL_API("DlgDirSelectComboBoxExW", DlgDirSelectComboBoxExW_fwd),
	DECL_API("DlgDirSelectExW", DlgDirSelectExW_fwd),
	DECL_API("DrawStateW", DrawStateW_fwd),
	DECL_API("DrawTextExW", DrawTextExW_fwd),
	DECL_API("DrawTextW", DrawTextW_fwd),
	DECL_API("EnumDisplayDevicesW", EnumDisplayDevicesW_fwd),
	DECL_API("EnumDisplaySettingsExW", EnumDisplaySettingsExW_fwd),
	DECL_API("EnumDisplaySettingsW", EnumDisplaySettingsW_fwd),
	DECL_API("EnumPropsExW", EnumPropsExW_fwd),
	DECL_API("EnumPropsW", EnumPropsW_fwd),
	DECL_API("FindWindowExW", FindWindowExW_fwd),
	DECL_API("FindWindowW", FindWindowW_fwd),
	DECL_API("GetAltTabInfoW", GetAltTabInfoW_fwd),
	DECL_API("GetClassNameW", GetClassNameW_fwd),
	DECL_API("GetClipboardFormatNameW", GetClipboardFormatNameW_fwd),
	DECL_API("GetKeyNameTextW", GetKeyNameTextW_fwd),
	DECL_API("GetKeyboardLayoutNameW", GetKeyboardLayoutNameW_fwd),
	DECL_API("GetMenuItemInfoW", GetMenuItemInfoW_fwd),
	DECL_API("GetMenuStringW", GetMenuStringW_fwd),
	DECL_API("GetMonitorInfoW", GetMonitorInfoW_fwd),
	DECL_API("GetPropW", GetPropW_fwd),
	DECL_API("GetTabbedTextExtentW", GetTabbedTextExtentW_fwd),
	DECL_API("GrayStringW", GrayStringW_fwd),
	DECL_API("InsertMenuItemW", InsertMenuItemW_fwd),
	DECL_API("LoadAcceleratorsW", LoadAcceleratorsW_fwd),
	DECL_API("LoadBitmapW", LoadBitmapW_fwd),
	DECL_API("LoadCursorFromFileW", LoadCursorFromFileW_fwd),
	DECL_API("LoadCursorW", LoadCursorW_fwd),
	DECL_API("LoadIconW", LoadIconW_fwd),
	DECL_API("LoadImageW", LoadImageW_fwd),
	DECL_API("LoadKeyboardLayoutW", LoadKeyboardLayoutW_fwd),
	DECL_API("MapVirtualKeyExW", MapVirtualKeyExW_fwd),
	DECL_API("MapVirtualKeyW", MapVirtualKeyW_fwd),
	DECL_API("MessageBoxIndirectW", MessageBoxIndirectW_fwd),
	DECL_API("RegisterClipboardFormatW", RegisterClipboardFormatW_fwd),
	DECL_API("RegisterDeviceNotificationW", RegisterDeviceNotificationW_fwd),
	DECL_API("RegisterWindowMessageW", RegisterWindowMessageW_fwd),
	DECL_API("RemovePropW", RemovePropW_fwd),
	DECL_API("SetMenuItemInfoW", SetMenuItemInfoW_fwd),
	DECL_API("SetPropW", SetPropW_fwd),
	DECL_API("SystemParametersInfoW", SystemParametersInfoW_fwd),
	DECL_API("TabbedTextOutW", TabbedTextOutW_fwd),
	DECL_API("VkKeyScanExW", VkKeyScanExW_fwd),
	DECL_API("VkKeyScanW", VkKeyScanW_fwd),
	DECL_API("WinHelpW", WinHelpW_fwd),
	DECL_API("wsprintfW", wsprintfW_fwd),
	DECL_API("wvsprintfW", wvsprintfW_fwd),
/*** AUTOGENERATED APILIST NAMED EXPORTS END ***/
};

#if 0
static const apilib_unnamed_api user32_ordinal_apis[] =
{
/*** AUTOGENERATED APILIST ORDINAL EXPORTS BEGIN ***/
/*** AUTOGENERATED APILIST ORDINAL EXPORTS END ***/
};
#endif

const apilib_api_table apitable_user32 = DECL_TAB("USER32.DLL", user32_named_apis, 0 /*user32_ordinal_apis*/);
