/*
 *  KernelEx
 *  Copyright (C) 2009, Xeno86
 *
 *  This file is part of KernelEx source code.
 *
 *  KernelEx is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation; version 2 of the License.
 *
 *  KernelEx is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Make; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "common.h"
#include "kexcoresdk.h"
#include "_winspool_apilist.h"

BOOL init_winspool()
{
	return TRUE;
}

static const apilib_named_api winspool_named_apis[] = 
{
/*** AUTOGENERATED APILIST NAMED EXPORTS BEGIN ***/
	DECL_API("AddJobW", AddJobW_fwd),
	DECL_API("AddMonitorW", AddMonitorW_fwd),
	DECL_API("AddPortW", AddPortW_fwd),
	DECL_API("AddPrintProcessorW", AddPrintProcessorW_fwd),
	DECL_API("AddPrintProvidorW", AddPrintProvidorW_fwd),
	DECL_API("AddPrinterDriverW", AddPrinterDriverW_fwd),
	DECL_API("AddPrinterW", AddPrinterW_fwd),
	DECL_API("AdvancedDocumentPropertiesW", AdvancedDocumentPropertiesW_fwd),
	DECL_API("ConfigurePortW", ConfigurePortW_fwd),
	DECL_API("DeleteMonitorW", DeleteMonitorW_fwd),
	DECL_API("DeletePortW", DeletePortW_fwd),
	DECL_API("DeletePrintProcessorW", DeletePrintProcessorW_fwd),
	DECL_API("DeletePrintProvidorW", DeletePrintProvidorW_fwd),
	DECL_API("DeletePrinterDriverW", DeletePrinterDriverW_fwd),
	DECL_API("DeviceCapabilitiesW", DeviceCapabilitiesW_fwd),
	DECL_API("DocumentPropertiesW", DocumentPropertiesW_fwd),
	DECL_API("EnumPrintersW", EnumPrintersW_new),
	DECL_API("GetDefaultPrinterA", GetDefaultPrinterA_new),
	DECL_API("GetDefaultPrinterW", GetDefaultPrinterW_new),
	DECL_API("GetPrintProcessorDirectoryW", GetPrintProcessorDirectoryW_fwd),
	DECL_API("GetPrinterDataExA", GetPrinterDataExA_stub),
	DECL_API("GetPrinterDataExW", GetPrinterDataExW_stub),
	DECL_API("GetPrinterDriverDirectoryW", GetPrinterDriverDirectoryW_fwd),
	DECL_API("OpenPrinterW", OpenPrinterW_fwd),
	DECL_API("ResetPrinterW", ResetPrinterW_fwd),
	DECL_API("SetJobW", SetJobW_fwd),
	DECL_API("SetPrinterDataExA", SetPrinterDataExA_stub),
	DECL_API("SetPrinterDataExW", SetPrinterDataExW_stub),
	DECL_API("SetPrinterDataW", SetPrinterDataW_fwd),
	DECL_API("SetPrinterW", SetPrinterW_fwd),
	DECL_API("StartDocPrinterW", StartDocPrinterW_fwd),
/*** AUTOGENERATED APILIST NAMED EXPORTS END ***/
};

#if 0
static const apilib_unnamed_api winspool_ordinal_apis[] =
{
/*** AUTOGENERATED APILIST ORDINAL EXPORTS BEGIN ***/
/*** AUTOGENERATED APILIST ORDINAL EXPORTS END ***/
};
#endif

const apilib_api_table apitable_winspool = DECL_TAB("WINSPOOL.DRV", winspool_named_apis, 0 /*winspool_ordinal_apis*/);
